org.eclipse.wst.jsdt.core.dom

## Class DefaultASTVisitor

- java.lang.Object
- - org.eclipse.wst.jsdt.core.dom.ASTVisitor
  - - org.eclipse.wst.jsdt.core.dom.DefaultASTVisitor

    public class DefaultASTVisitor
    extends ASTVisitor

An `ASTVisitor` that can be configured to have a default implementation for all nodes. Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.

### Constructor Summary

Constructors
Constructor and Description
`DefaultASTVisitor()`
`DefaultASTVisitor(boolean visitDocTags)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `endVisit(AnonymousClassDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(ArrayAccess node)` End of visit the given type-specific AST node.
`void` `endVisit(ArrayCreation node)` End of visit the given type-specific AST node.
`void` `endVisit(ArrayInitializer node)` End of visit the given type-specific AST node.
`void` `endVisit(ArrayName node)` End of visit the given type-specific AST node.
`void` `endVisit(ArrayType node)` End of visit the given type-specific AST node.
`void` `endVisit(Assignment node)` End of visit the given type-specific AST node.
`void` `endVisit(AssignmentName node)` End of visit the given type-specific AST node.
`void` `endVisit(Block node)` End of visit the given type-specific AST node.
`void` `endVisit(BlockComment node)` End of visit the given type-specific AST node.
`void` `endVisit(BooleanLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(BreakStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(CatchClause node)` End of visit the given type-specific AST node.
`void` `endVisit(CharacterLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(ClassInstanceCreation node)` End of visit the given type-specific AST node.
`void` `endVisit(ConditionalExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(ConstructorInvocation node)` End of visit the given type-specific AST node.
`void` `endVisit(ContinueStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(DebuggerStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(DoStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(EmptyStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(EnhancedForStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(ExportDeclaration node)`
`void` `endVisit(ExpressionStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(FieldAccess node)` End of visit the given type-specific AST node.
`void` `endVisit(FieldDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(ForInStatement node)`
`void` `endVisit(ForOfStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(ForStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(FunctionDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(FunctionDeclarationStatement node)`
`void` `endVisit(FunctionExpression node)`
`void` `endVisit(FunctionInvocation node)` End of visit the given type-specific AST node.
`void` `endVisit(FunctionRef node)` End of visit the given type-specific AST node.
`void` `endVisit(FunctionRefParameter node)` End of visit the given type-specific AST node.
`void` `endVisit(IfStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(ImportDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(InferredType node)`
`void` `endVisit(InfixExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(Initializer node)` End of visit the given type-specific AST node.
`void` `endVisit(InstanceofExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(JavaScriptUnit node)` End of visit the given type-specific AST node.
`void` `endVisit(JSdoc node)` End of visit the given type-specific AST node.
`void` `endVisit(LabeledStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(LineComment node)` End of visit the given type-specific AST node.
`void` `endVisit(ListExpression node)`
`void` `endVisit(MemberRef node)` End of visit the given type-specific AST node.
`void` `endVisit(MetaProperty node)` End of visit the given type-specific AST node.
`void` `endVisit(ModuleSpecifier node)` End of visit the given type-specific AST node.
`void` `endVisit(NullLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(NumberLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(ObjectLiteral node)`
`void` `endVisit(ObjectLiteralField node)`
`void` `endVisit(ObjectName node)` End of visit the given type-specific AST node.
`void` `endVisit(PackageDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(ParenthesizedExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(PostfixExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(PrefixExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(PrimitiveType node)` End of visit the given type-specific AST node.
`void` `endVisit(QualifiedName node)` End of visit the given type-specific AST node.
`void` `endVisit(QualifiedType node)` End of visit the given type-specific AST node.
`void` `endVisit(RegularExpressionLiteral node)`
`void` `endVisit(RestElementName node)` End of visit the given type-specific AST node.
`void` `endVisit(ReturnStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(SimpleName node)` End of visit the given type-specific AST node.
`void` `endVisit(SimpleType node)` End of visit the given type-specific AST node.
`void` `endVisit(SingleVariableDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(SpreadElement node)` End of visit the given type-specific AST node.
`void` `endVisit(StringLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(SuperConstructorInvocation node)` End of visit the given type-specific AST node.
`void` `endVisit(SuperFieldAccess node)` End of visit the given type-specific AST node.
`void` `endVisit(SuperMethodInvocation node)` End of visit the given type-specific AST node.
`void` `endVisit(SwitchCase node)` End of visit the given type-specific AST node.
`void` `endVisit(SwitchStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(TagElement node)` End of visit the given type-specific AST node.
`void` `endVisit(TemplateElement node)` End of visit the given type-specific AST node.
`void` `endVisit(TemplateLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(TextElement node)` End of visit the given type-specific AST node.
`void` `endVisit(ThisExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(ThrowStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(TryStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(TypeDeclaration node)` End of visit the given type-specific AST node.
`void` `endVisit(TypeDeclarationExpression node)`
`void` `endVisit(TypeDeclarationStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(TypeLiteral node)` End of visit the given type-specific AST node.
`void` `endVisit(UndefinedLiteral node)`
`void` `endVisit(VariableDeclarationExpression node)` End of visit the given type-specific AST node.
`void` `endVisit(VariableDeclarationFragment node)` End of visit the given type-specific AST node.
`void` `endVisit(VariableDeclarationStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(WhileStatement node)` End of visit the given type-specific AST node.
`void` `endVisit(WithStatement node)`
`void` `endVisit(YieldExpression node)` End of visit the given type-specific AST node.
`protected void` `endVisitNode(ASTNode node)`
`boolean` `visit(AnonymousClassDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(ArrayAccess node)` Visits the given type-specific AST node.
`boolean` `visit(ArrayCreation node)` Visits the given type-specific AST node.
`boolean` `visit(ArrayInitializer node)` Visits the given type-specific AST node.
`boolean` `visit(ArrayName node)` Visits the given type-specific AST node.
`boolean` `visit(ArrayType node)` Visits the given type-specific AST node.
`boolean` `visit(ArrowFunctionExpression node)` Visits the given type-specific AST node.
`boolean` `visit(Assignment node)` Visits the given type-specific AST node.
`boolean` `visit(AssignmentName node)` Visits the given type-specific AST node.
`boolean` `visit(Block node)` Visits the given type-specific AST node.
`boolean` `visit(BlockComment node)` Visits the given type-specific AST node.
`boolean` `visit(BooleanLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(BreakStatement node)` Visits the given type-specific AST node.
`boolean` `visit(CatchClause node)` Visits the given type-specific AST node.
`boolean` `visit(CharacterLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(ClassInstanceCreation node)` Visits the given type-specific AST node.
`boolean` `visit(ConditionalExpression node)` Visits the given type-specific AST node.
`boolean` `visit(ConstructorInvocation node)` Visits the given type-specific AST node.
`boolean` `visit(ContinueStatement node)` Visits the given type-specific AST node.
`boolean` `visit(DebuggerStatement node)` Visits the given type-specific AST node.
`boolean` `visit(DoStatement node)` Visits the given type-specific AST node.
`boolean` `visit(EmptyStatement node)` Visits the given type-specific AST node.
`boolean` `visit(EnhancedForStatement node)` Visits the given type-specific AST node.
`boolean` `visit(ExportDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(ExpressionStatement node)` Visits the given type-specific AST node.
`boolean` `visit(FieldAccess node)` Visits the given type-specific AST node.
`boolean` `visit(FieldDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(ForInStatement node)`
`boolean` `visit(ForOfStatement node)` Visits the given type-specific AST node.
`boolean` `visit(ForStatement node)` Visits the given type-specific AST node.
`boolean` `visit(FunctionDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(FunctionDeclarationStatement node)` Visits the given type-specific AST node.
`boolean` `visit(FunctionExpression node)`
`boolean` `visit(FunctionInvocation node)` Visits the given type-specific AST node.
`boolean` `visit(FunctionRef node)` Visits the given type-specific AST node.
`boolean` `visit(FunctionRefParameter node)` Visits the given type-specific AST node.
`boolean` `visit(IfStatement node)` Visits the given type-specific AST node.
`boolean` `visit(ImportDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(InferredType node)`
`boolean` `visit(InfixExpression node)` Visits the given type-specific AST node.
`boolean` `visit(Initializer node)` Visits the given type-specific AST node.
`boolean` `visit(InstanceofExpression node)` Visits the given type-specific AST node.
`boolean` `visit(JavaScriptUnit node)` Visits the given type-specific AST node.
`boolean` `visit(JSdoc node)` Visits the given AST node.
`boolean` `visit(LabeledStatement node)` Visits the given type-specific AST node.
`boolean` `visit(LineComment node)` Visits the given type-specific AST node.
`boolean` `visit(ListExpression node)`
`boolean` `visit(MemberRef node)` Visits the given type-specific AST node.
`boolean` `visit(MetaProperty node)` Visits the given type-specific AST node.
`boolean` `visit(Modifier node)` Visits the given type-specific AST node.
`boolean` `visit(ModuleSpecifier node)` Visits the given type-specific AST node.
`boolean` `visit(NullLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(NumberLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(ObjectLiteral node)`
`boolean` `visit(ObjectLiteralField node)`
`boolean` `visit(ObjectName node)` Visits the given type-specific AST node.
`boolean` `visit(PackageDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(ParenthesizedExpression node)` Visits the given type-specific AST node.
`boolean` `visit(PostfixExpression node)` Visits the given type-specific AST node.
`boolean` `visit(PrefixExpression node)` Visits the given type-specific AST node.
`boolean` `visit(PrimitiveType node)` Visits the given type-specific AST node.
`boolean` `visit(QualifiedName node)` Visits the given type-specific AST node.
`boolean` `visit(QualifiedType node)` Visits the given type-specific AST node.
`boolean` `visit(RegularExpressionLiteral node)`
`boolean` `visit(RestElementName node)` Visits the given type-specific AST node.
`boolean` `visit(ReturnStatement node)` Visits the given type-specific AST node.
`boolean` `visit(SimpleName node)` Visits the given type-specific AST node.
`boolean` `visit(SimpleType node)` Visits the given type-specific AST node.
`boolean` `visit(SingleVariableDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(SpreadElement node)` Visits the given type-specific AST node.
`boolean` `visit(StringLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(SuperConstructorInvocation node)` Visits the given type-specific AST node.
`boolean` `visit(SuperFieldAccess node)` Visits the given type-specific AST node.
`boolean` `visit(SuperMethodInvocation node)` Visits the given type-specific AST node.
`boolean` `visit(SwitchCase node)` Visits the given type-specific AST node.
`boolean` `visit(SwitchStatement node)` Visits the given type-specific AST node.
`boolean` `visit(TagElement node)` Visits the given type-specific AST node.
`boolean` `visit(TemplateElement node)` Visits the given type-specific AST node.
`boolean` `visit(TemplateLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(TextElement node)` Visits the given type-specific AST node.
`boolean` `visit(ThisExpression node)` Visits the given type-specific AST node.
`boolean` `visit(ThrowStatement node)` Visits the given type-specific AST node.
`boolean` `visit(TryStatement node)` Visits the given type-specific AST node.
`boolean` `visit(TypeDeclaration node)` Visits the given type-specific AST node.
`boolean` `visit(TypeDeclarationExpression node)` Visits the given type-specific AST node.
`boolean` `visit(TypeDeclarationStatement node)` Visits the given type-specific AST node.
`boolean` `visit(TypeLiteral node)` Visits the given type-specific AST node.
`boolean` `visit(UndefinedLiteral node)`
`boolean` `visit(VariableDeclarationExpression node)` Visits the given type-specific AST node.
`boolean` `visit(VariableDeclarationFragment node)` Visits the given type-specific AST node.
`boolean` `visit(VariableDeclarationStatement node)` Visits the given type-specific AST node.
`boolean` `visit(WhileStatement node)` Visits the given type-specific AST node.
`boolean` `visit(WithStatement node)`
`boolean` `visit(YieldExpression node)` Visits the given type-specific AST node.
`protected boolean` `visitNode(ASTNode node)`

### Methods inherited from class org.eclipse.wst.jsdt.core.dom.ASTVisitor

`endVisit, endVisit, postVisit, preVisit`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DefaultASTVisitor

    public DefaultASTVisitor()

#### DefaultASTVisitor

    public DefaultASTVisitor(boolean visitDocTags)

### Method Detail

#### endVisit

    public void endVisit(AnonymousClassDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ArrayAccess node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ArrayCreation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ArrayInitializer node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ArrayType node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(Assignment node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(Block node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(BlockComment node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Note: `LineComment` and `BlockComment` nodes are not considered part of main structure of the AST. This method will only be called if a client goes out of their way to visit this kind of node explicitly.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(BooleanLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(BreakStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(CatchClause node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(CharacterLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ClassInstanceCreation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(JavaScriptUnit node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ConditionalExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ConstructorInvocation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ContinueStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(DoStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(EmptyStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(EnhancedForStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ExpressionStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FieldAccess node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FieldDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ForInStatement node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ForStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FunctionExpression node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(IfStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ImportDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(InferredType node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(InfixExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(Initializer node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(InstanceofExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(JSdoc node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(LabeledStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(LineComment node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Note: `LineComment` and `BlockComment` nodes are not considered part of main structure of the AST. This method will only be called if a client goes out of their way to visit this kind of node explicitly.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ListExpression node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(MemberRef node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FunctionDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FunctionInvocation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FunctionRef node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(FunctionRefParameter node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(NullLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(NumberLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ObjectLiteral node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ObjectLiteralField node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(PackageDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ParenthesizedExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(PostfixExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(PrefixExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(PrimitiveType node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(QualifiedName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(QualifiedType node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(RegularExpressionLiteral node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ReturnStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SimpleName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SimpleType node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SingleVariableDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(StringLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SuperConstructorInvocation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SuperFieldAccess node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SuperMethodInvocation node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SwitchCase node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(SwitchStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TagElement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TextElement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ThisExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(ThrowStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TryStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TypeDeclaration node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TypeDeclarationStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(TypeLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(UndefinedLiteral node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(VariableDeclarationExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(VariableDeclarationFragment node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(VariableDeclarationStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(WhileStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit

#### endVisit

    public void endVisit(WithStatement node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ForOfStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(YieldExpression node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(DebuggerStatement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ArrayName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ObjectName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(TemplateElement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(TemplateLiteral node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(AssignmentName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(RestElementName node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(SpreadElement node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(MetaProperty node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ModuleSpecifier node)

Description copied from class: `ASTVisitor`
End of visit the given type-specific AST node.

The default implementation does nothing. Subclasses may reimplement.

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(ExportDeclaration node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(TypeDeclarationExpression node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisit

    public void endVisit(FunctionDeclarationStatement node)

Overrides:
  `endVisit` in class `ASTVisitor`

#### endVisitNode

    protected void endVisitNode(ASTNode node)

#### visit

    public boolean visit(AnonymousClassDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrayAccess node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrayCreation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrayInitializer node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrayType node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(Assignment node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(Block node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(BlockComment node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Note: `LineComment` and `BlockComment` nodes are not considered part of main structure of the AST. This method will only be called if a client goes out of their way to visit this kind of node explicitly.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(BooleanLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(BreakStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(CatchClause node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(CharacterLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ClassInstanceCreation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(JavaScriptUnit node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ConditionalExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ConstructorInvocation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ContinueStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(DoStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(EmptyStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(EnhancedForStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ExpressionStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FieldAccess node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FieldDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ForInStatement node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(ForStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionExpression node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(IfStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ImportDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(InferredType node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(InfixExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(Initializer node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(InstanceofExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(JSdoc node)

Description copied from class: `ASTVisitor`
Visits the given AST node.

Unlike other node types, the boolean returned by the default implementation is controlled by a constructor-supplied parameter `ASTVisitor(boolean)` which is `false` by default. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped
See Also:
  `ASTVisitor.ASTVisitor()`, `ASTVisitor.ASTVisitor(boolean)`

#### visit

    public boolean visit(LabeledStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(LineComment node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Note: `LineComment` and `BlockComment` nodes are not considered part of main structure of the AST. This method will only be called if a client goes out of their way to visit this kind of node explicitly.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ListExpression node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(MemberRef node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionInvocation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionRef node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionRefParameter node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(NullLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(NumberLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ObjectLiteral node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(ObjectLiteralField node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(PackageDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ParenthesizedExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(PostfixExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(PrefixExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(PrimitiveType node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(QualifiedName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(QualifiedType node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(RegularExpressionLiteral node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(ReturnStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SimpleName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SimpleType node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SingleVariableDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(StringLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SuperConstructorInvocation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SuperFieldAccess node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SuperMethodInvocation node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SwitchCase node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SwitchStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TagElement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TextElement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ThisExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ThrowStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TryStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TypeDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TypeDeclarationStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TypeLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(UndefinedLiteral node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(VariableDeclarationExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(VariableDeclarationFragment node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(VariableDeclarationStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(WhileStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(WithStatement node)

Overrides:
  `visit` in class `ASTVisitor`

#### visit

    public boolean visit(ForOfStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(Modifier node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Parameters:
  `node` - the node to visit
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(YieldExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrowFunctionExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(DebuggerStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ArrayName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ObjectName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TemplateElement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TemplateLiteral node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(AssignmentName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(RestElementName node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(SpreadElement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(MetaProperty node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ModuleSpecifier node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(ExportDeclaration node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(TypeDeclarationExpression node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visit

    public boolean visit(FunctionDeclarationStatement node)

Description copied from class: `ASTVisitor`
Visits the given type-specific AST node.

The default implementation does nothing and return true. Subclasses may reimplement.

Overrides:
  `visit` in class `ASTVisitor`
Returns:
  `true` if the children of this node should be visited, and `false` if the children of this node should be skipped

#### visitNode

    protected boolean visitNode(ASTNode node)